#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <ctype.h>
#include <grp.h>
//----------------------------------------------------------
static void usage (void);
//----------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
  char *group;
  int gid;
  struct group *grs;
  struct stat file_status;
  int a;        // Argument index.
  int status;
  // 
  // 
  // 
  if (argc < 3)
    {
      usage ();
      return (1);
    }
  // 
  // Get group id number.
  // 
  group = argv[1];
  if (isdigit (*group))
    {
      gid = atoi (group);
    }
  else
    {
      grs = getgrnam (group);
      if (grs == NULL)
        {
          fprintf (stderr, "Unknown group \"%s\"!\n",
                   group);
          return (2);
        }
      gid = grs->gr_gid;
    }
  // 
  // Now we have the group id. Start scanning file
  // names.
  // 
  for (a = 2; a < argc; a++)
    {
      // 
      // Verify if the file exists, through the return 
      // value of
      // `stat()'. No other checks are made.
      // 
      if (stat (argv[a], &file_status) == 0)
        {
          // 
          // Try to change ownership.
          // 
          status = chown (argv[a], file_status.st_uid, gid);
          if (status != 0)
            {
              perror (NULL);
              return (3);
            }
        }
      else
        {
          fprintf (stderr,
                   "File \"%s\" does not exist!\n",
                   argv[a]);
          continue;
        }
    }
  // 
  // All done.
  // 
  return (0);
}

//----------------------------------------------------------
static void
usage (void)
{
  fprintf (stderr, "Usage:   chown GROUP|UID FILE...\n");
  fprintf (stderr, "Example: chown group my_file\n");
}
