#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/wait.h>
#include <limits.h>
#include <sys/os32.h>
#include <fcntl.h>
#include <stdio.h>
//----------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
  char *device_name;
  int fdn;
  char *exec_argv[2];
  char **exec_envp;
  char buffer[BUFSIZ];
  ssize_t size_read;
  int status;
  // 
  // The first argument is mandatory and must be a
  // console terminal.
  // 
  device_name = argv[1];
  // 
  // A console terminal is correctly selected (but it
  // is not checked
  // if it is a really available one).
  // Set as a process group leader.
  // 
  setpgrp ();
  // 
  // Open the terminal, that should become the
  // controlling terminal:
  // close the standard input and open the new
  // terminal (r/w).
  // 
  close (0);
  fdn = open (device_name, O_RDWR);
  if (fdn < 0)
    {
      // 
      // Cannot open terminal. A message should
      // appear, at least
      // to the current console.
      // 
      perror (NULL);
      return (-1);
    }
  // 
  // Reset terminal device permissions and ownership.
  // 
  status = fchown (fdn, (uid_t) 0, (gid_t) 0);
  if (status != 0)
    {
      perror (NULL);
    }
  status = fchmod (fdn, 0644);
  if (status != 0)
    {
      perror (NULL);
    }
  // 
  // The terminal is open and it should be already the 
  // controlling
  // one: show `/etc/issue'. The same variable `fdn'
  // is used, because
  // the controlling terminal will never be closed
  // (the exit syscall
  // will do it).
  // 
  fdn = open ("/etc/issue", O_RDONLY);
  if (fdn > 0)
    {
      // 
      // The file is present and is shown.
      // 
      for (size_read = 1; size_read > 0;)
        {
          size_read =
            read (fdn, buffer, (size_t) (BUFSIZ - 1));
          if (size_read < 0)
            {
              break;
            }
          buffer[size_read] = '\0';
          printf ("%s", buffer);
        }
      close (fdn);
    }
  // 
  // Show the terminal.
  // 
  printf ("This is terminal %s\n", device_name);
  // 
  // It is time to exec login: the environment is
  // inherited directly
  // from `init'.
  // 
  exec_argv[0] = "login";
  exec_argv[1] = NULL;
  exec_envp = envp;
  execve ("/bin/login", exec_argv, exec_envp);
  // 
  // If `execve()' returns, it is an error.
  // 
  exit (-1);
}
