#include <sys/os32.h>
#include <kernel/net.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
//----------------------------------------------------------
#define NET_BUFFER_MAX 1024     // [1]
//
// [1] Enough to be able to read important data from
//     the `net_table[]', without stack overflow.
//     In fact, the table `net_table[]' contains
//     also the interface frames, and there is no sense
//     to read a full item.
//
//----------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
  int fd;
  ssize_t size_read;
  char buffer[NET_BUFFER_MAX];
  int n;
  net_t *net_table_item;
  char string[80];

  // 
  // All options are ignored, at the moment.
  // 

  // 
  // Open `/dev/kmem_net', to get the network
  // interface table.
  // 
  fd = open ("/dev/kmem_net", O_RDONLY);
  if (fd < 0)
    {
      printf ("[%s] Cannot open \"/dev/kmem_net\" ",
              argv[0]);
      perror (NULL);
      exit (0);
    }
  // 
  // Print header.
  // 
  printf ("dev   "
          "address/mask        "
          "mac                " "io      irq\n");
  // 
  // Scan NET items and then print body.
  // 
  for (n = 0; n < NET_MAX_DEVICES; n++)
    {
      lseek (fd, (off_t) n, SEEK_SET);
      size_read = read (fd, buffer, NET_BUFFER_MAX);
      if (size_read < NET_BUFFER_MAX)
        {
          printf
            ("[%s] Cannot read \"/dev/kmem_net\" "
             "item %i ", argv[0], n);
          perror (NULL);
          continue;
        }
      net_table_item = (net_t *) buffer;
      if (net_table_item->type != NET_DEV_NULL)
        {
          sprintf (string, "net%i    ", n);
          string[6] = '\0';
          printf ("%s", string);
          // 
          sprintf (string, "%i.%i.%i.%i/%i "
                   "               ",
                   net_table_item->ip >> 24 & 0x000000FF,
                   net_table_item->ip >> 16 & 0x000000FF,
                   net_table_item->ip >> 8 & 0x000000FF,
                   net_table_item->ip >> 0 & 0x000000FF,
                   net_table_item->m);
          string[20] = '\0';
          printf ("%s", string);
          // 
          if (net_table_item->type & NET_DEV_ETH)
            {
              printf
                ("%02x:%02x:%02x:%02x:%02x:%02x  "
                 "0x%04x  %i",
                 net_table_item->ethernet.mac[0],
                 net_table_item->ethernet.mac[1],
                 net_table_item->ethernet.mac[2],
                 net_table_item->ethernet.mac[3],
                 net_table_item->ethernet.mac[4],
                 net_table_item->ethernet.mac[5],
                 net_table_item->ethernet.base_io,
                 net_table_item->ethernet.irq);
            }
          printf ("\n");
        }
    }
  close (fd);
  return (0);
}
