#include <fcntl.h>
#include <sys/stat.h>
#include <stddef.h>
#include <unistd.h>
#include <errno.h>
//----------------------------------------------------------
static void usage (void);
//----------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
  int a;        // Argument index.
  int status;
  struct stat file_status;
  // 
  // No options are known, but at least an argument
  // must be given.
  // 
  if (argc < 2)
    {
      usage ();
      return (1);
    }
  // 
  // Scan arguments.
  // 
  for (a = 1; a < argc; a++)
    {
      // 
      // Verify if the file exists.
      // 
      if (stat (argv[a], &file_status) != 0)
        {
          fprintf (stderr,
                   "File \"%s\" does not exist!\n",
                   argv[a]);
          continue;
        }
      // 
      // File exists: check the file type.
      // 
      if (!S_ISDIR (file_status.st_mode))
        {
          fprintf (stderr,
                   "Cannot remove file \"%s\"!\n", argv[a]);
          continue;
        }
      // 
      // Can try to remove it.
      // 
      status = rmdir (argv[a]);
      if (status != 0)
        {
          perror (NULL);
          return (2);
        }
    }
  return (0);
}

//----------------------------------------------------------
static void
usage (void)
{
  fprintf (stderr, "Usage: rmdir DIR...\n");
}
