#include <sys/os32.h>
#include <kernel/net/route.h>
#include <kernel/net.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
//----------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
  int fd;
  ssize_t size_read;
  char buffer[sizeof (route_t)];
  int n;
  route_t *route_table_item;
  char string[80];

  // 
  // All options are ignored, at the moment
  // 

  // 
  // Open `/dev/kmem_route', to get the routing table.
  // 
  fd = open ("/dev/kmem_route", O_RDONLY);
  if (fd < 0)
    {
      printf ("[%s] Cannot open \"/dev/kmem_route\" ",
              argv[0]);
      perror (NULL);
      exit (0);
    }
  // 
  // Print header.
  // 
  printf ("Destination/mask   "
          "Router          " "Interface\n");
  // 
  // Scan route table items and then print body.
  // 
  for (n = 0; n < ROUTE_MAX_ROUTES; n++)
    {
      lseek (fd, (off_t) n, SEEK_SET);
      size_read = read (fd, buffer, sizeof (route_t));
      if (size_read < sizeof (route_t))
        {
          printf
            ("[%s] Cannot read "
             "\"/dev/kmem_route\" item %i ", argv[0], n);
          perror (NULL);
          continue;
        }
      // 
      route_table_item = (route_t *) buffer;
      // 
      if (route_table_item->network == 0xFFFFFFFF)
        {
          // 
          // Empty item.
          // 
          continue;
        }
      // 
      sprintf (string, "%i.%i.%i.%i/%i"
               "                    ",
               route_table_item->network >> 24 & 0x000000FF,
               route_table_item->network >> 16 & 0x000000FF,
               route_table_item->network >> 8 & 0x000000FF,
               route_table_item->network >> 0 & 0x000000FF,
               route_table_item->m);
      string[19] = '\0';
      printf ("%s", string);
      // 
      if (route_table_item->router == 0)
        {
          printf ("                ");
        }
      else
        {
          sprintf (string, "%i.%i.%i.%i"
                   "           ",
                   route_table_item->router >> 24 &
                   0x000000FF,
                   route_table_item->router >> 16 &
                   0x000000FF,
                   route_table_item->router >> 8 &
                   0x000000FF,
                   route_table_item->router >> 0 &
                   0x000000FF);
          string[16] = '\0';
          printf ("%s", string);
        }
      // 
      printf ("net%i\n", route_table_item->interface);
    }
  close (fd);
  return (0);
}
