#include <fcntl.h>
#include <sys/stat.h>
#include <utime.h>
#include <stddef.h>
#include <unistd.h>
#include <errno.h>
#include <sys/os32.h>
#include <sys/types.h>
//----------------------------------------------------------
static void usage (void);
//----------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
  int dev_minor;
  struct stat file_status;
  // 
  // No options and no arguments.
  // 
  if (argc > 1)
    {
      usage ();
      return (1);
    }
  // 
  // Verify the standard input.
  // 
  if (fstat (STDIN_FILENO, &file_status) == 0)
    {
      if (major (file_status.st_rdev) == DEV_CONSOLE_MAJOR)
        {
          dev_minor = minor (file_status.st_rdev);
          // 
          // If minor is equal to 0xFF, it is
          // `/dev/console'
          // that is not a controlling terminal, but
          // just
          // a reference for the current virtual
          // console.
          // 
          if (dev_minor < 0xFF)
            {
              printf ("/dev/console%i\n", dev_minor);
            }
        }
    }
  else
    {
      perror ("Cannot get standard input file status");
      return (2);
    }
  // 
  return (0);
}

//----------------------------------------------------------
static void
usage (void)
{
  fprintf (stderr, "Usage: tty\n");
}
