/*****************************************************
 * The code will start at address 0x100000, that is at
 * 1 Mibyte, because it is the place where GRUB will
 * place it.
 *
 * The kernel is divided into `TEXT' (code), `DATA' and
 * `BSS'.
 * Between the TEXT and the DATA there is a gap to
 * align the data at 4 Kibyte boundary (0x1000), to
 * allow memory management for it.
 *
 * The stack will be placed at the beginning of the
 * BSS.
 *
 * The kernel starts with file `kernel/main/crt0.s',
 * at the label `startup'.
 *****************************************************/
ENTRY (kstartup)
SECTIONS {
    . = 0x00100000;
    _k_start = .;
    _k_text_start = .;
    .text : {
        *(.text)
    }
    _k_text_end = .;
    . = ALIGN (0x1000);
    _k_data_start = .;
    .rodata : {
        *(.rodata)
    }
    . = ALIGN (0x4);
    .data : {
        *(.data)
    }
    _k_data_end = .;
    . = ALIGN (0x4);
    _k_bss_start = .;
    .bss : {
        *(COMMON)
        *(.bss)
    }
    _k_bss_end = .;
    _k_end = .;
}
