#include <kernel/blk.h>
#include <string.h>
#include <kernel/lib_k.h>
//----------------------------------------------------------
void
blk_cache_check (void)
{
  int i;
  int j;
  // 
  // check if all ages are present.
  // 
  for (i = 0; i < BLK_CACHE_SIZE; i++)
    {
      if (blk_table[i].age > BLK_CACHE_MAX_AGE)
        {
          k_printf
            ("blk_table[%i].age > BLK_CACHE_MAX_AGE\n", i);
          return;
        }
      for (j = 0; j < BLK_CACHE_SIZE; j++)
        {
          if (j != i
              && blk_table[i].age == blk_table[j].age)
            {
              k_printf
                ("blk_table[%i].age == "
                 "blk_table[%i].age\n", i, j);
              return;
            }
        }
    }
}
