#include <kernel/driver/ata.h>
#include <kernel/lib_s.h>
#include <kernel/ibm_i386.h>
#include <stdint.h>
#include <errno.h>
//----------------------------------------------------------
int
ata_lba28 (int drive, unsigned int sector,
           unsigned char count)
{
  int s;
  unsigned char low;
  unsigned char mid;
  unsigned char high;
  // 
  // Register `device'.
  // 
  s = ata_device (drive, sector);
  if (s < 0)
    {
      k_perror (NULL);

      errset (errno);
      return (-1);
    }
  // 
  // Register `control', to set nIEN.
  // 
  out_8 (ata_table[drive].r_control, ATA_CONTROL_NIEN);
  // 
  // Register `feature'. not used.
  // 
  out_8 (ata_table[drive].r_feature, 0);
  // 
  // Register `count'
  // 
  out_8 (ata_table[drive].r_count, count);
  // 
  // Registers `low', `mid', `high'.
  // 
  low = (sector & 0x000000FF);
  mid = ((sector & 0x0000FF00) >> 8);
  high = ((sector & 0x00FF0000) >> 16);
  // 
  out_8 (ata_table[drive].r_low, low);
  out_8 (ata_table[drive].r_mid, mid);
  out_8 (ata_table[drive].r_high, high);
  // 
  // Ok.
  // 
  return (0);
}
