#include <kernel/driver/kbd.h>
//----------------------------------------------------------
void
kbd_load (void)
{
  int i;
  // 
  // Reset the map.
  // 
  for (i = 0; i <= 127; i++)
    {
      kbd.map1[i] = 0;
      kbd.map2[i] = 0;
    }
  // 
  // Association for an italian map, but only with
  // ASCII characters
  // (there are no accented letters).
  // 
  kbd.map1[1] = 27;
  kbd.map2[1] = 27;     // ESC
  kbd.map1[2] = '1';
  kbd.map2[2] = '!';
  kbd.map1[3] = '2';
  kbd.map2[3] = '"';
  kbd.map1[4] = '3';
  kbd.map2[4] = 'L';    // 3, £
  kbd.map1[5] = '4';
  kbd.map2[5] = '$';
  kbd.map1[6] = '5';
  kbd.map2[6] = '%';
  kbd.map1[7] = '6';
  kbd.map2[7] = '&';
  kbd.map1[8] = '7';
  kbd.map2[8] = '/';
  kbd.map1[9] = '8';
  kbd.map2[9] = '(';
  kbd.map1[10] = '9';
  kbd.map2[10] = ')';
  kbd.map1[11] = '0';
  kbd.map2[11] = '=';
  kbd.map1[12] = '\'';
  kbd.map2[12] = '?';
  kbd.map1[13] = 'i';
  kbd.map2[13] = '^';   // ì, ^
  kbd.map1[14] = '\b';
  kbd.map2[14] = '\b';  // Backspace
  kbd.map1[15] = '\t';
  kbd.map2[15] = '\t';
  kbd.map1[16] = 'q';
  kbd.map2[16] = 'Q';
  kbd.map1[17] = 'w';
  kbd.map2[17] = 'W';
  kbd.map1[18] = 'e';
  kbd.map2[18] = 'E';
  kbd.map1[19] = 'r';
  kbd.map2[19] = 'R';
  kbd.map1[20] = 't';
  kbd.map2[20] = 'T';
  kbd.map1[21] = 'y';
  kbd.map2[21] = 'Y';
  kbd.map1[22] = 'u';
  kbd.map2[22] = 'U';
  kbd.map1[23] = 'i';
  kbd.map2[23] = 'I';
  kbd.map1[24] = 'o';
  kbd.map2[24] = 'O';
  kbd.map1[25] = 'p';
  kbd.map2[25] = 'P';
  kbd.map1[26] = '[';
  kbd.map2[26] = '{';   // è, é
  kbd.map1[27] = ']';
  kbd.map2[27] = '}';   // +, *
  kbd.map1[28] = '\n';
  kbd.map2[28] = '\n';  // Enter
  kbd.map1[30] = 'a';
  kbd.map2[30] = 'A';
  kbd.map1[31] = 's';
  kbd.map2[31] = 'S';
  kbd.map1[32] = 'd';
  kbd.map2[32] = 'D';
  kbd.map1[33] = 'f';
  kbd.map2[33] = 'F';
  kbd.map1[34] = 'g';
  kbd.map2[34] = 'G';
  kbd.map1[35] = 'h';
  kbd.map2[35] = 'H';
  kbd.map1[36] = 'j';
  kbd.map2[36] = 'J';
  kbd.map1[37] = 'k';
  kbd.map2[37] = 'K';
  kbd.map1[38] = 'l';
  kbd.map2[38] = 'L';
  kbd.map1[39] = '@';
  kbd.map2[39] = '@';   // ò, ç
  kbd.map1[40] = '#';
  kbd.map2[40] = '#';   // à, °
  kbd.map1[41] = '\\';
  kbd.map2[41] = '|';
  kbd.map1[43] = 'u';
  kbd.map2[43] = 'U';   // ù, §
  kbd.map1[44] = 'z';
  kbd.map2[44] = 'Z';
  kbd.map1[45] = 'x';
  kbd.map2[45] = 'X';
  kbd.map1[46] = 'c';
  kbd.map2[46] = 'C';
  kbd.map1[47] = 'v';
  kbd.map2[47] = 'V';
  kbd.map1[48] = 'b';
  kbd.map2[48] = 'B';
  kbd.map1[49] = 'n';
  kbd.map2[49] = 'N';
  kbd.map1[50] = 'm';
  kbd.map2[50] = 'M';
  kbd.map1[51] = ',';
  kbd.map2[51] = ';';
  kbd.map1[52] = '.';
  kbd.map2[52] = ':';
  kbd.map1[53] = '-';
  kbd.map2[53] = '_';
  kbd.map1[56] = '<';
  kbd.map2[56] = '>';
  kbd.map1[57] = ' ';
  kbd.map2[57] = ' ';
  // 
  kbd.map1[55] = '*';
  kbd.map2[55] = '*';
  kbd.map1[71] = '7';
  kbd.map2[71] = '7';
  kbd.map1[72] = '8';
  kbd.map2[72] = '8';
  kbd.map1[73] = '9';
  kbd.map2[73] = '9';
  kbd.map1[74] = '-';
  kbd.map2[74] = '-';
  kbd.map1[75] = '4';
  kbd.map2[75] = '4';
  kbd.map1[76] = '5';
  kbd.map2[76] = '5';
  kbd.map1[77] = '6';
  kbd.map2[77] = '6';
  kbd.map1[78] = '+';
  kbd.map2[78] = '+';
  kbd.map1[79] = '1';
  kbd.map2[79] = '1';
  kbd.map1[80] = '2';
  kbd.map2[80] = '2';
  kbd.map1[81] = '3';
  kbd.map2[81] = '3';
  kbd.map1[82] = '0';
  kbd.map2[82] = '0';
  kbd.map1[83] = '.';
  kbd.map2[83] = '.';
  kbd.map1[92] = '/';
  kbd.map2[92] = '/';
  kbd.map1[96] = '\n';
  kbd.map2[96] = '\n';  // Enter
}
