#include <kernel/driver/nic/ne2k.h>
#include <kernel/ibm_i386.h>
#include <kernel/lib_k.h>
#include <errno.h>
#include <unistd.h>
#include <time.h>
//----------------------------------------------------------
#define DEBUG 0
//----------------------------------------------------------
int
ne2k_isr_expect (uintptr_t io, unsigned int isr_expect)
{
  int retry = 5;
  int status;
  // 
  // 
  // 
  for (; retry > 0; retry--)
    {
      status = in_8 (io + NE2K_ISR);
      // 
      if (status & isr_expect)
        {
          // 
          // Reset the bit found true and exit loop.
          // 
          out_8 ((io + NE2K_ISR), isr_expect);
          return (0);
        }
    }
  // 
  // If ISR is zero, we assume that it is ok.
  // 
  if (status == 0)
    {
      if (DEBUG)
        {
          k_printf ("[isr=0x%02x expect=0x%02x]",
                    status, isr_expect);
          return (0);
        }
      return (0);
    }
  else
    {
      if (DEBUG)
        {
          // 
          // It is not zero, but we prefer to let it
          // go...
          // 
          k_printf ("[isr=0x%02x expect=0x%02x]",
                    status, isr_expect);
          return (0);
        }
      else
        {
          errset (E_DRIVER_FAULT);
          return (-1);
        }
    }
}
