#include <kernel/driver/screen.h>
#include <stddef.h>
#include <errno.h>
#include <kernel/lib_k.h>
//----------------------------------------------------------
int
screen_number (screen_t * screen)
{
  ptrdiff_t distance;
  int n;
  // 
  if (screen == NULL)
    {
      errset (EINVAL);
      return (-1);
    }
  // 
  distance = (void *) screen - (void *) &screen_table[0];
  // 
  n = (distance % (sizeof (screen_t)));
  // 
  if (n != 0)
    {
      errset (EINVAL);  // Invalid pointer placement.
      return (-1);
    }
  // 
  n = (distance / (sizeof (screen_t)));
  // 
  if (n < 0 || n > SCREEN_MAX)
    {
      errset (EINVAL);  // Pointer outside the screen
      // table.
      return (-1);
    }
  // 
  // If we are here, variable `n' holds the right
  // screen number.
  // 
  return (n);
}
