#include <kernel/driver/screen.h>
#include <errno.h>
//----------------------------------------------------------
int
screen_putc (screen_t * screen, int c)
{
  int row;
  int col;
  // 
  if (screen == NULL)
    {
      errset (EINVAL);
      return (-1);
    }
  // 
  // Find row-col position on screen.
  // 
  row = (screen->position / SCREEN_COLS);
  col = (screen->position - (row * SCREEN_COLS));
  // 
  // 
  // 
  if (c == '\n' || c == '\r')
    {
      screen_new_line (screen);
      return (0);
    }
  else if (c == '\b')
    {
      screen->position--;
      if (screen->position < 0)
        {
          screen->position = 0;
        }
      screen_update (screen);
      return (0);
    }
  else if (screen->position == (SCREEN_CELLS - 1))
    {
      // 
      // It is not a control character and we are
      // already at the
      // last cell of the last row.
      // 
      screen_scroll (screen);
    }
  // 
  // If we are here, it is not a control character.
  // So: print it.
  // 
  screen->cell[screen->position] =
    screen_cell (c, VGA_ATTR);
  screen->position++;
  screen_update (screen);
  // 
  return (0);
}
