#include <kernel/driver/screen.h>
#include <errno.h>
#include <kernel/ibm_i386.h>
//----------------------------------------------------------
int
screen_select (screen_t * screen)
{
  int scrn;
  // 
  if (screen == NULL)
    {
      errset (EINVAL);
      return (-1);
    }
  // 
  // Get screen number.
  // 
  scrn = screen_number (screen);
  if (scrn < 0)
    {
      errset (EINVAL);  // The screen pointer was
      // invalid.
      return (-1);
    }
  // 
  // Set the current screen, update the screen memory
  // and put the cursor.
  // 
  screen_active = scrn;
  // 
  screen_update (screen);
  // 
  // Ok.
  // 
  return (0);
}
