#ifndef _KERNEL_DRIVER_TTY_H
#define _KERNEL_DRIVER_TTY_H  1
//----------------------------------------------------------
#include <stddef.h>
#include <stdint.h>
#include <stdio.h>
#include <sys/types.h>
#include <kernel/ibm_i386.h>
#include <termios.h>
//----------------------------------------------------------
#define   TTYS_CONSOLE    4
#define   TTYS_SERIAL     0
#define   TTYS_TOTAL      (TTYS_CONSOLE + TTYS_SERIAL)
//----------------------------------------------------------
#define   TTY_INPUT_LINE_EDITING 0
#define   TTY_INPUT_LINE_CLOSED  1
//----------------------------------------------------------
typedef struct
{
  dev_t device;
  pid_t pgrp;   // Process group.
  struct termios attr;  // termios attributes.
  unsigned char status; // 0 = edit, 1 = end edit.
  char line[MAX_CANON]; // Canonical input line.
  int lpr;      // Input line position read.
  int lpw;      // Input line position write.
} tty_t;
//----------------------------------------------------------
extern tty_t tty_table[TTYS_TOTAL];
//----------------------------------------------------------
tty_t *tty_reference (dev_t device);
dev_t tty_console (dev_t device);
int tty_read (dev_t device);
void tty_write (dev_t device, int c);
void tty_init (void);
//----------------------------------------------------------
#endif
