#include <kernel/fs.h>
#include <errno.h>
#include <kernel/lib_k.h>
//----------------------------------------------------------
blkcnt_t
inode_fzones_write (inode_t * inode, zno_t zone_start,
                    void *buffer, blkcnt_t blkcnt)
{
  unsigned char *source = (unsigned char *) buffer;
  int status;   // `zone_read()' return value.
  blkcnt_t blkcnt_written;      // Written zones
  // counter.
  zno_t zone;
  zno_t fzone;
  // 
  // Write the zones into the destination buffer.
  // 
  for (blkcnt_written = 0, fzone = zone_start;
       blkcnt_written < blkcnt; blkcnt_written++, fzone++)
    {
      // 
      // Find real zone from file-zone.
      // 
      zone = inode_zone (inode, fzone, 1);
      if (zone == 0 || zone == ((zno_t) - 1))
        {
          // 
          // Function `inode_zone()' should allocate
          // automatically
          // a missing zone and should return a valid
          // zone or
          // (zno_t) -1. Anyway, even if a zero zone
          // is returned,
          // it is an error. Return the
          // `blkcnt_written' value.
          // 
          return (blkcnt_written);
        }
      // 
      // Update the source buffer pointer for the next 
      // zone write.
      // 
      source += (blkcnt_written * inode->sb->blksize);
      // 
      // Write the zone from the buffer content.
      // 
      status = zone_write (inode->sb, zone, source);
      if (status != 0)
        {
          // 
          // Cannot write the zone. Return
          // `size_written_zone' value.
          // 
          return (blkcnt_written);
        }
    }
  // 
  // All zones read correctly inside the buffer.
  // 
  return (blkcnt_written);
}
