#include <kernel/fs.h>
#include <errno.h>
#include <kernel/proc.h>
//----------------------------------------------------------
dev_t
path_device (pid_t pid, const char *path)
{
  proc_t *ps;
  inode_t *inode;
  dev_t device;
  // 
  // Get process.
  // 
  ps = proc_reference (pid);
  // 
  inode = path_inode (pid, path);
  if (inode == NULL)
    {
      errset (errno);
      return ((dev_t) - 1);
    }
  // 
  if (!(S_ISBLK (inode->mode) || S_ISCHR (inode->mode)))
    {
      errset (ENODEV);  // No such device.
      inode_put (inode);
      return ((dev_t) - 1);
    }
  // 
  device = inode->direct[0];
  inode_put (inode);
  return (device);
}
