#include <kernel/fs.h>
#include <errno.h>
//----------------------------------------------------------
int
sb_inode_status (sb_t * sb, ino_t ino)
{
  int map_element;
  int map_bit;
  int map_mask;
  // 
  // Check arguments.
  // 
  if (ino == 0 || sb == NULL)
    {
      errset (EINVAL);  // Invalid argument.
      return (-1);
    }
  // 
  // Calculate the map element, the map bit and the
  // map mask.
  // 
  map_element = ino / 16;
  map_bit = ino % 16;
  map_mask = 1 << map_bit;
  // 
  // Check the inode and return.
  // 
  if (sb->map_inode[map_element] & map_mask)
    {
      return (1);       // True.
    }
  else
    {
      return (0);       // False.
    }
}
