#include <kernel/fs.h>
#include <errno.h>
//----------------------------------------------------------
sb_t *
sb_reference (dev_t device)
{
  int s;        // Slot index.
  // 
  // If device is zero, a reference to the whole table 
  // is returned.
  // 
  if (device == 0)
    {
      return (sb_table);
    }
  // 
  // If device is ((dev_t) -1), a reference to a free
  // slot is
  // returned.
  // 
  if (device == ((dev_t) - 1))
    {
      for (s = 0; s < SB_MAX_SLOTS; s++)
        {
          if (sb_table[s].device == 0)
            {
              return (&sb_table[s]);
            }
        }
      return (NULL);
    }
  // 
  // A device was selected: find the super block
  // associated to it.
  // 
  for (s = 0; s < SB_MAX_SLOTS; s++)
    {
      if (sb_table[s].device == device)
        {
          return (&sb_table[s]);
        }
    }
  // 
  // The super block was not found.
  // 
  return (NULL);
}
