#include <sys/os32.h>
#include <kernel/fs.h>
#include <kernel/dev.h>
#include <errno.h>
//----------------------------------------------------------
int
zone_read (sb_t * sb, zno_t zone, void *buffer)
{
  size_t size_zone;
  off_t off_start;
  ssize_t size_read;
  // 
  // Verify if the requested zone is inside the file
  // system area.
  // 
  if (zone >= sb->zones)
    {
      errset (EINVAL);  // Invalid argument.
      return (-1);
    }
  // 
  // Calculate start position.
  // 
  size_zone = 1024 << sb->log2_size_zone;
  off_start = zone;
  off_start *= size_zone;
  // 
  // Read from device to the buffer.
  // 
  size_read =
    dev_io ((pid_t) - 1, sb->device, DEV_READ,
            off_start, buffer, size_zone, NULL);
  if (size_read != size_zone)
    {
      errset (EIO);     // I/O error.
      return (-1);
    }
  else
    {
      return (0);
    }
}
