.globl  gdt_load
#
gdt_load:
    enter $0, $0
    .equ gdtr_pointer,  8          # Primo argomento.
    mov  gdtr_pointer(%ebp), %eax  # Copia il
                                   # puntatore in EAX.
    leave
    #
    lgdt (%eax)         # Carica il registro GDTR
                        # dall'indirizzo in EAX.
    #
    # 2 kernel data, included stack, DPL 0, covering
    #   all the available
    #   memory: segment selector 0x10+0.
    #
    mov  $16, %ax
    mov  %ax, %ds
    mov  %ax, %es
    mov  %ax, %fs
    mov  %ax, %gs
    mov  %ax, %ss       # The stack MUST be in the same
                        # address space of the other
                        # data, to allow pointers to
    #                   # work correctly.
    #
    # 2 kernel code, DPL 0, covering all the available
    #   memory:
    #   segment selector 0x08+0.
    #
    jmp  $8, $flush
flush:
    ret
