#include <kernel/ibm_i386.h>
#include <kernel/lib_k.h>
//
void
gdt_print (void *gdtr, unsigned int first,
           unsigned int last)
{
  gdtr_t *g = gdtr;
  uint32_t *p = (uint32_t *) g->base;
  // 
  int max = (g->limit + 1) / (sizeof (uint32_t));
  int i;
  // 
  if (((first * 2) > max) || (first > last))
    {
      return;
    }
  // 
  k_printf ("[%s] base: 0x%08" PRIX32 " limit: 0x%04"
            PRIX32 "\n", __func__, g->base, g->limit);
  // 
  for (i = (first * 2); i < max && i <= (last * 2); i += 2)
    {
      k_printf ("[%4" PRIx32 "] %032" PRIb32 " %032"
                PRIb32 "\n", i / 2, p[i], p[i + 1]);
    }
}
