#include <kernel/ibm_i386.h>
//----------------------------------------------------------
void
idt_descriptor (int desc,
                void *isr,
                uint16_t selector,
                bool present, char type, char dpl)
{
  uint32_t offset = (uint32_t) isr;
  // 
  // Unset reserved bits and the system bit.
  // 
  idt_table[desc].filler = 0;
  idt_table[desc].system = 0;
  // 
  // Relative address.
  // 
  idt_table[desc].offset_a = (offset & 0x0000FFFF);
  idt_table[desc].offset_b = (offset / 0x10000);
  // 
  // Selector.
  // 
  idt_table[desc].selector = selector;
  // 
  // Valid item?
  // 
  idt_table[desc].present = present;
  // 
  // Type (gate type).
  // 
  idt_table[desc].type = (type & 0x0F);
  // 
  // DPL.
  // 
  idt_table[desc].dpl = (dpl & 0x03);
}
