#include <kernel/ibm_i386.h>
#include <stdint.h>
//----------------------------------------------------------
void
irq_on (unsigned int irq)
{
  uint32_t mask;
  uint32_t status;
  // 
  if (irq > 15)
    {
      return;   // There is not such IRQ.
    }
  else
    {
      mask = ~((uint32_t) 1 << irq);
      // 
      // IRQ from 0 to 7.
      // 
      status = in_8 ((uint32_t) 0x21);
      status = status & mask;
      out_8 ((uint32_t) 0x21, status);
      // 
      // IRQ from 8 to 15.
      // 
      status = in_8 ((uint32_t) 0xA1);
      status = status & (mask >> 8);
      out_8 ((uint32_t) 0xA1, status);
    }
}
