.extern isr_exception_unrecoverable
.extern isr_irq_clear
.extern isr_irq_clear_pic1
.extern isr_irq_clear_pic2
.extern kbd_isr
.extern sysroutine
.extern proc_current
.extern proc_stack_segment_selector;
.extern proc_stack_pointer
.extern proc_scheduler
#.extern proc_sch_terminals
#
.global _clock_kernel
.global _clock_time
.global _ksp
#
.global isr_0
.global isr_1
.global isr_2
.global isr_3
.global isr_4
.global isr_5
.global isr_6
.global isr_7
.global isr_8
.global isr_9
.global isr_10
.global isr_11
.global isr_12
.global isr_13
.global isr_14
.global isr_15
.global isr_16
.global isr_17
.global isr_18
.global isr_19
.global isr_20
.global isr_21
.global isr_22
.global isr_23
.global isr_24
.global isr_25
.global isr_26
.global isr_27
.global isr_28
.global isr_29
.global isr_30
.global isr_31
.global isr_32
.global isr_33
.global isr_34
.global isr_35
.global isr_36
.global isr_37
.global isr_38
.global isr_39
.global isr_40
.global isr_41
.global isr_42
.global isr_43
.global isr_44
.global isr_45
.global isr_46
.global isr_47
.global isr_128
#------------------------------------------------------
.section .data
#------------------------------------------------------
proc_syscallnr:              .int   0x00000000
proc_msg_offset:             .int   0x00000000
proc_msg_size:               .int   0x00000000
proc_instruction_pointer:    .int   0x00000000
proc_back_address:           .int   0x00000000
_ksp:                        .int   0x00000000
syscall_working:             .int   0x00000000
_clock_kernel:
kticks_lo:                   .int   0x00000000
kticks_hi:                   .int   0x00000000
_clock_time:
tticks_lo:                   .int   0x00000000
tticks_hi:                   .int   0x00000000
#------------------------------------------------------
.section .text
#------------------------------------------------------
#
# Inside the stack there is already, placed by the CPU:
#   [omissis]
#   push %eflags
#   push %cs
#   push %eip
#
#------------------------------------------------------
isr_0:          # «division by zero exception»
    cli
    push $0     # Null error code.
    push $0     # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_1:          # «debug exception»
    cli
    push $0     # Null error code.
    push $1     # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_2:          # «non maskable interrupt exception»
    cli
    push $0     # Null error code.
    push $2     # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_3:          # «breakpoint exception»
    cli
    push $0     # Null error code.
    push $3     # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_4:          # «into detected overflow exception»
    cli
    push $0     # Null error code.
    push $4     # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_5:          # «out of bounds exception»
    cli
    push $0     # Null error code.
    push $5     # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_6:          # «invalid opcode exception»
    cli
    push $0     # Null error code.
    push $6     # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_7:          # «no coprocessor exception»
    cli
    push $0     # Null error code.
    push $7     # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_8:          # «double fault exception»
    cli
    #           # Error code already present.
    push $8     # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_9:          # «coprocessor segment overrun
                # exception»
    cli
    push $0     # Null error code.
    push $9     # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_10:         # «bad TSS exception»
    cli
    #           # Error code already present.
    push $10    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_11:         # «segment not present exception»
    cli
    #           # Error code already present.
    push $11    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_12:         # «stack fault exception»
    cli
    #           # Error code already present.
    push $12    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_13:         # «general protection fault exception»
    cli
    #           # Error code already present.
    push $13    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_14:         # «page fault exception»
    cli
    #           # Error code already present.
    push $14    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_15:         # «unknown interrupt exception»
    cli
    push $0     # Null error code.
    push $15    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_16:         # «coprocessor fault exception»
    cli
    push $0     # Null error code.
    push $16    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_17:         # «alignment check exception»
    cli
    push $0     # Null error code.
    push $17    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_18:         # «machine check exception»
    cli
    push $0     # Null error code.
    push $18    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_19:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $19    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_20:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $20    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_21:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $21    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_22:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $22    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_23:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $23    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_24:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $24    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_25:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $25    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_26:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $26    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_27:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $27    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_28:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $28    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_29:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $29    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_30:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $30    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_31:         # «reserved exception»
    cli
    push $0     # Null error code.
    push $31    # Exception number.
    jmp exception_unrecoverable
#------------------------------------------------------
isr_32:         # IRQ 0: «timer»
    cli
    jmp irq_timer
#------------------------------------------------------
isr_33:         # IRQ 1: tastiera
    cli
    jmp irq_keyboard
#------------------------------------------------------
isr_34:         # IRQ 2: it is fired for IRQ 8 to 15.
    cli
    #
    # IRQ 2 must be ON inside the file
    # `kernel/proc/proc_init.c', so
    # that it is guaranteed that the PIC 1 is reset
    # here.
    #
    call isr_irq_clear_pic1
    #
    # For IRQ 2 there is nothing else to do, because it
    # is a link to the PIC 2 (IRQ 8 to 15).
    #
    iret
#------------------------------------------------------
isr_35:         # IRQ 3 
    cli
    jmp irq_pic1
#------------------------------------------------------
isr_36:         # IRQ 4
    cli
    jmp irq_pic1
#------------------------------------------------------
isr_37:         # IRQ 5
    cli
    jmp irq_pic1
#------------------------------------------------------
isr_38:         # IRQ 6: floppy disk drive
    cli
    jmp irq_pic1
#------------------------------------------------------
isr_39:         # IRQ 7: LPT 1
    cli
    jmp irq_pic1
#------------------------------------------------------
isr_40:         # IRQ 8: «real time clock (RTC)»
    cli
    jmp irq_pic2
#------------------------------------------------------
isr_41:         # IRQ 9
    cli
    jmp irq_pic2
#------------------------------------------------------
isr_42:         # IRQ 10
    cli
    jmp irq_pic2
#------------------------------------------------------
isr_43:         # IRQ 11
    cli
    jmp irq_pic2
#------------------------------------------------------
isr_44:         # IRQ 12: mouse PS/2
    cli
    jmp irq_pic2
#------------------------------------------------------
isr_45:         # IRQ 13: math coprocessor
    cli
    jmp irq_pic2
#------------------------------------------------------
isr_46:         # IRQ 14: primary IDE channel
    cli
    jmp irq_pic2
#------------------------------------------------------
isr_47:         # IRQ 15: secondary IDE channel
    cli
    jmp irq_pic2
#------------------------------------------------------
#
# Unrecoverable exceptions.
#
exception_unrecoverable:
    #
    # Previous pushes:
    #   [omissis]
    #   push %eflags
    #   push %cs
    #   push %eip
    #
    #   push $<error_number>
    #   push $<idt_item_number>
    #
    pushl %gs
    pushl %fs
    pushl %es
    pushl %ds
    pushl %edi
    pushl %esi
    pushl %ebp
    pushl %ebx
    pushl %edx
    pushl %ecx
    pushl %eax
    #
    call isr_exception_unrecoverable
    #
    popl %eax
    popl %ecx
    popl %edx
    popl %ebx
    popl %ebp
    popl %esi
    popl %edi
    popl %ds
    popl %es
    popl %fs
    popl %gs
    #
    # Remove the IDT item number and the error code.
    #
    add $4, %esp
    add $4, %esp
    #
    # Return from interrupt.
    #
    iret
#------------------------------------------------------
#
# Unspecified IRQ. Currently unused.
#
irq:
    #
    # Previous pushes:
    #   [omissis]
    #   push %eflags
    #   push %cs
    #   push %eip
    #
    #   push $0
    #   push $<idt_item_number>
    #
    call isr_irq_clear
    #
    # Remove the IDT item number and the null error
    # code.
    #
    add $4, %esp
    add $4, %esp
    #
    # Return from interrupt.
    #
    iret
#------------------------------------------------------
#
# Keyboard IRQ.
#
irq_keyboard:
    #
    # Previous pushes:
    #   [omissis]
    #   push %eflags
    #   push %cs
    #   push %eip
    #
    pushl %gs
    pushl %fs
    pushl %es
    pushl %ds
    pushl %edi
    pushl %esi
    pushl %ebp
    pushl %ebx
    pushl %edx
    pushl %ecx
    pushl %eax
    #
    # Set the data segments to the kernel data segment,
    # so that the following variables can be accessed.
    #
    mov  $16, %ax # DS, ES, FS and GS.
    mov  %ax, %ds
    mov  %ax, %es
    mov  %ax, %fs
    mov  %ax, %gs
    #
    # Check if a system call is already working: if so,
    # just leave (go to L1).
    #
    cmpl $1, syscall_working
    je L1
    #
    # Call the keyboard handler.
    #
    call kbd_isr
    #
L1: # Restore original registers and return.
    #
    jmp irq_pic1_pop_iret
#------------------------------------------------------
#
# Generic IRQ from PIC 1
#
irq_pic1:
    #
    # Previous pushes:
    #   [omissis]
    #   push %eflags
    #   push %cs
    #   push %eip
    #
    pushl %gs
    pushl %fs
    pushl %es
    pushl %ds
    pushl %edi
    pushl %esi
    pushl %ebp
    pushl %ebx
    pushl %edx
    pushl %ecx
    pushl %eax
    #
    # Set the data segments to the kernel data segment,
    # so that the following variables can be accessed.
    #
    mov  $16, %ax # DS, ES, FS and GS.
    mov  %ax, %ds
    mov  %ax, %es
    mov  %ax, %fs
    mov  %ax, %gs
    #
    # Check if a system call is already working: if so,
    # just leave (go to L2).
    #
    cmpl $1, syscall_working
    je L2
    #
    # If we are here, no system call is working and a
    # user process was interrupted.
    # Save process stack registers into kernel data
    # segment.
    #
    mov %ss,  proc_stack_segment_selector
    mov %esp, proc_stack_pointer
    #
    # Check if it is already in kernel mode: the kernel
    # has PID 0.
    # If so, just leave (go to L2).
    #
    mov proc_current, %edx       # Interrupted PID.
    mov $0,           %eax       # Kernel PID.
    cmp %eax, %edx
    je L5
    #
    # If we are here, a user process was interrupted.
    # Switch to the kernel stack (data segment
    # descriptor).
    #
    mov $16, %ax
    mov %ax, %ss
    mov _ksp, %esp
    #
    # Call the scheduler.
    #
    call proc_scheduler
    #
    # Restore process stack registers from kernel data
    # segment.
    #
    mov proc_stack_segment_selector, %ss
    mov proc_stack_pointer, %esp
    #
L5: # Restore from process stack and return.
    #
    jmp irq_pic1_pop_iret
#------------------------------------------------------
#
# Generic IRQ from PIC 2
#
irq_pic2:
    #
    # Previous pushes:
    #   [omissis]
    #   push %eflags
    #   push %cs
    #   push %eip
    #
    pushl %gs
    pushl %fs
    pushl %es
    pushl %ds
    pushl %edi
    pushl %esi
    pushl %ebp
    pushl %ebx
    pushl %edx
    pushl %ecx
    pushl %eax
    #
    # Set the data segments to the kernel data segment,
    # so that the following variables can be accessed.
    #
    mov  $16, %ax # DS, ES, FS and GS.
    mov  %ax, %ds
    mov  %ax, %es
    mov  %ax, %fs
    mov  %ax, %gs
    #
    # Check if a system call is already working: if so,
    # just leave (go to L2).
    #
    cmpl $1, syscall_working
    je L2
    #
    # If we are here, no system call is working and a
    # user process was interrupted.
    # Save process stack registers into kernel data
    # segment.
    #
    mov %ss,  proc_stack_segment_selector
    mov %esp, proc_stack_pointer
    #
    # Check if it is already in kernel mode: the kernel
    # has PID 0.
    # If so, just leave (go to L2).
    #
    mov proc_current, %edx       # Interrupted PID.
    mov $0,           %eax       # Kernel PID.
    cmp %eax, %edx
    je L4
    #
    # If we are here, a user process was interrupted.
    # Switch to the kernel stack (data segment
    # descriptor).
    #
    mov $16, %ax
    mov %ax, %ss
    mov _ksp, %esp
    #
    # Call the scheduler.
    #
    call proc_scheduler
    #
    # Restore process stack registers from kernel data
    # segment.
    #
    mov proc_stack_segment_selector, %ss
    mov proc_stack_pointer, %esp
    #
L4: # Restore from process stack and return.
    #
    jmp irq_pic2_pop_iret
#------------------------------------------------------
#
# Timer IRQ.
#
irq_timer:
    #
    # Previous pushes:
    #   [omissis]
    #   push %eflags
    #   push %cs
    #   push %eip
    #
    pushl %gs
    pushl %fs
    pushl %es
    pushl %ds
    pushl %edi
    pushl %esi
    pushl %ebp
    pushl %ebx
    pushl %edx
    pushl %ecx
    pushl %eax
    #
    # Set the data segments to the kernel data segment,
    # so that the following variables can be accessed.
    #
    mov  $16, %ax # DS, ES, FS and GS.
    mov  %ax, %ds
    mov  %ax, %es
    mov  %ax, %fs
    mov  %ax, %gs
    #
    # Increment time counters, to keep time.
    #
    add $1, kticks_lo    # Kernel ticks counter.
    adc $0, kticks_hi    #
    #
    add $1, tticks_lo    # Clock ticks counter.
    adc $0, tticks_hi    #
    #
    # Check if a system call is already working: if so,
    # just leave (go to L2).
    #
    cmpl $1, syscall_working
    je L2
    #
    # If we are here, no system call is working and a
    # user process was interrupted.
    # Save process stack registers into kernel data
    # segment.
    #
    mov %ss,  proc_stack_segment_selector
    mov %esp, proc_stack_pointer
    #
    # Check if it is already in kernel mode: the kernel
    # has PID 0.
    # If so, just leave (go to L2).
    #
    mov proc_current, %edx       # Interrupted PID.
    mov $0,           %eax       # Kernel PID.
    cmp %eax, %edx
    je L2
    #
    # If we are here, a user process was interrupted.
    # Switch to the kernel stack (data segment
    # descriptor).
    #
    mov $16, %ax
    mov %ax, %ss
    mov _ksp, %esp
    #
    # Call the scheduler.
    #
    call proc_scheduler
    #
    # Restore process stack registers from kernel data
    # segment.
    #
    mov proc_stack_segment_selector, %ss
    mov proc_stack_pointer, %esp
    #
L2: # Restore from process stack and return.
    #
    jmp irq_pic1_pop_iret
#------------------------------------------------------
irq_pic1_pop_iret:
    #
    # Restore from process stack.
    #
    popl %eax
    popl %ecx
    popl %edx
    popl %ebx
    popl %ebp
    popl %esi
    popl %edi
    popl %ds
    popl %es
    popl %fs
    popl %gs
    #
    # End of hardware interrupt to PIC 1.
    #
    call isr_irq_clear_pic1
    #
    # Return from interrupt.
    #
    iret
#------------------------------------------------------
irq_pic2_pop_iret:
    #
    # Restore from process stack.
    #
    popl %eax
    popl %ecx
    popl %edx
    popl %ebx
    popl %ebp
    popl %esi
    popl %edi
    popl %ds
    popl %es
    popl %fs
    popl %gs
    #
    # End of hardware interrupt to PIC 2 and PIC1.
    #
    call isr_irq_clear_pic2
    #
    # Return from interrupt.
    #
    iret
#------------------------------------------------------
#
# System call.
#
isr_128:
    #
    # Previous pushes:
    #   [omissis]
    #   push message_size
    #   push &message_structure
    #   push syscall_number
    #   push back_address   # made by a call to sys()
    #   push %eflags        # made by int $128 (0x80)
    #   push %cs            # made by int $128 (0x80)
    #   push %eip           # made by int $128 (0x80)
    #
    #--------------------------------------------------
    #
    # Save into process stack:
    #
    pushl %gs
    pushl %fs
    pushl %es
    pushl %ds
    pushl %edi
    pushl %esi
    pushl %ebp
    pushl %ebx
    pushl %edx
    pushl %ecx
    pushl %eax
    #
    # Set the data segments to the kernel data segment.
    #
    mov  $16, %ax # DS, ES, FS and GS.
    mov  %ax, %ds
    mov  %ax, %es
    mov  %ax, %fs
    mov  %ax, %gs
    #
    # Tell that it is a system call.
    #
    movl $1, syscall_working
    #
    # Save process stack registers into kernel data
    # segment.
    #
    mov %ss,  proc_stack_segment_selector
    mov %esp, proc_stack_pointer
    #
    # Save some more data, from the system call.
    #
    .equ SYSCALL_NUMBER,      60
    .equ MESSAGE_OFFSET,      64
    .equ MESSAGE_SIZE,        68
    #
    mov %esp, %ebp
    mov SYSCALL_NUMBER(%ebp), %eax
    mov %eax, proc_syscallnr
    mov MESSAGE_OFFSET(%ebp), %eax
    mov %eax, proc_msg_offset
    mov MESSAGE_SIZE(%ebp), %eax
    mov %eax, proc_msg_size
    #
    # Check if it is already in kernel mode: the kernel
    # has PID 0.
    #
    mov proc_current, %edx       # Interrupted PID.
    mov $0,           %eax       # Kernel PID.
    cmp %eax, %edx
    jne L3
    #
    # It is already the kernel stack, so, the variable
    # "_ksp" is aligned to current stack pointer.
    # This way, the first syscall
    # can work without having to set the "_ksp"
    # variable to some reasonable value.
    #
    mov %esp, _ksp
    #
L3: # Switch to the kernel stack (data segment
    # descriptor).
    #
    mov $16, %ax
    mov %ax, %ss
    mov _ksp, %esp
    #
    # Call the external sysroutine handler.
    #
    push proc_msg_size
    push proc_msg_offset
    push proc_syscallnr
    call sysroutine
    add $4, %esp
    add $4, %esp
    add $4, %esp
    #
    # Restore process stack registers from kernel data
    # segment.
    #
    mov proc_stack_segment_selector, %ss
    mov proc_stack_pointer, %esp
    #
    # End of system call.
    #
    movl $0, syscall_working
    #
    # Restore from process stack.
    #
    popl %eax
    popl %ecx
    popl %edx
    popl %ebx
    popl %ebp
    popl %esi
    popl %edi
    popl %ds
    popl %es
    popl %fs
    popl %gs
    #
    # Return from interrupt.
    #
    iret
#------------------------------------------------------
