#include <kernel/ibm_i386.h>
#include <kernel/lib_k.h>
#include <sys/types.h>
//----------------------------------------------------------
void
isr_exception_unrecoverable (uint32_t eax,
                             uint32_t ecx,
                             uint32_t edx,
                             uint32_t ebx,
                             uint32_t ebp,
                             uint32_t esi,
                             uint32_t edi, uint32_t ds,
                             uint32_t es, uint32_t fs,
                             uint32_t gs,
                             uint32_t interrupt,
                             uint32_t error,
                             uint32_t eip, uint32_t cs,
                             uint32_t eflags)
{
  pid_t pid = cs / 8;
  // 
  k_printf
    ("[%s] ERROR: pid: %i exception %i: \"%s\"\n",
     __func__, pid, interrupt,
     isr_exception_name (interrupt));
  // 
  // Exit the unrecoverable application.
  // 
  k_exit ();
}
