#include <arpa/inet.h>
#include <sys/os32.h>
#include <kernel/net/route.h>
#include <kernel/lib_k.h>
#include <errno.h>
#include <netinet/in.h>
#include <kernel/proc.h>
//----------------------------------------------------------
// This syscall is present only inside os32.
//----------------------------------------------------------
int
s_routedel (pid_t pid, in_addr_t dest, int m)
{
  int r;
  h_addr_t network;
  // 
  // Must be a privileged process.
  // 
  if (proc_table[pid].euid != 0)
    {
      errset (EPERM);
      return (-1);
    }
  // 
  // 
  // 
  if (m > 32 || m < 0)
    {
      errset (EINVAL);
      return (-1);
    }
  // 
  // Calculate the destination network with the mask.
  // 
  network = ntohl (dest) & ip_mask (m);
  // 
  // Check if there is already. If there is: remove
  // it.
  // 
  for (r = 0; r < ROUTE_MAX_ROUTES; r++)
    {
      if (network == route_table[r].network
          && m == route_table[r].m)
        {
          // 
          // Remove.
          // 
          memset (&route_table[m], 0xFF,
                  sizeof (route_table[m]));
          return (0);
        }
    }
  // 
  // Not found.
  // 
  errset (EINVAL);
  return (-1);
}
