#include <kernel/proc.h>
#include <kernel/lib_s.h>
#include <errno.h>
//----------------------------------------------------------
int
s_setgid (pid_t pid, gid_t gid)
{
  if ((proc_table[pid].euid == 0)
      || (proc_table[pid].egid == 0))
    {
      proc_table[pid].gid = gid;
      proc_table[pid].egid = gid;
      proc_table[pid].sgid = gid;
      return (0);
    }
  else if (gid == proc_table[pid].egid)
    {
      return (0);
    }
  else if (gid == proc_table[pid].gid
           || gid == proc_table[pid].sgid)
    {
      proc_table[pid].egid = gid;
      return (0);
    }
  else
    {
      errset (EPERM);
      return (-1);
    }
}
