#include <kernel/proc.h>
#include <kernel/lib_s.h>
#include <errno.h>
//----------------------------------------------------------
int
s_setuid (pid_t pid, uid_t uid)
{
  if (proc_table[pid].euid == 0)
    {
      proc_table[pid].uid = uid;
      proc_table[pid].euid = uid;
      proc_table[pid].suid = uid;
      return (0);
    }
  else if (uid == proc_table[pid].euid)
    {
      return (0);
    }
  else if (uid == proc_table[pid].uid
           || uid == proc_table[pid].suid)
    {
      proc_table[pid].euid = uid;
      return (0);
    }
  else
    {
      errset (EPERM);
      return (-1);
    }
}
