#ifndef _KERNEL_MULTIBOOT_H
#define _KERNEL_MULTIBOOT_H    1
//----------------------------------------------------------
#include <inttypes.h>
//----------------------------------------------------------
#define MBOOT_CMDLINE_MAX           4096
#define MBOOT_CMDLINE_OPTION_MAX    1024
#define MBOOT_CMDLINE_ARGUMENTS_MAX 32
//----------------------------------------------------------
typedef struct
{
  uint32_t flags;
  uint32_t mem_lower;
  uint32_t mem_upper;
  uint32_t boot_device;
  char *cmdline;
} multiboot_t;
//
typedef struct
{
  uint32_t flags;
  uint32_t mem_lower;
  uint32_t mem_upper;
  uint32_t boot_device;
  char cmdline[MBOOT_CMDLINE_MAX];
} multiboot_save_t;
//
extern multiboot_save_t multiboot;
//----------------------------------------------------------
void mboot_save (multiboot_t * mboot_data);
char **mboot_cmdline_opt (const char *opt,
                          const char *delim);
//----------------------------------------------------------
#endif
