#include <sys/os32.h>
#include <kernel/lib_k.h>
#include <arpa/inet.h>
#include <kernel/net.h>
#include <kernel/net/ip.h>
#include <kernel/net/icmp.h>
#include <errno.h>
//----------------------------------------------------------
#define DEBUG 0
//----------------------------------------------------------
int
icmp_tx (h_addr_t src, h_addr_t dst,
         int type, int code, icmp_packet_t * icmp,
         size_t size)
{
  uint16_t checksum;
  // 
  // Fill the ICMP header.
  // 
  icmp->header.type = type;
  icmp->header.code = code;
  icmp->header.checksum = 0;
  // 
  // Set the header checksum.
  // 
  checksum =
    ~(ip_checksum ((void *) icmp, size, NULL, (size_t) 0));
  icmp->header.checksum = htons (checksum);
  // 
  // Send to the lower network level.
  // 
  return (ip_tx
          (src, dst, IPPROTO_ICMP, (void *) icmp, size));
}
