#include <stdint.h>
#include <arpa/inet.h>
#include <kernel/net/ip.h>
//----------------------------------------------------------
uint16_t
ip_checksum (uint16_t * data1, size_t size1,
             uint16_t * data2, size_t size2)
{
  int i;
  uint32_t sum;
  uint16_t carry;
  uint16_t checksum;
  uint16_t last;
  uint8_t *octet;
  // 
  // 2's complement sum.
  // 
  sum = 0;
  // 
  if (data1 != NULL)
    {
      for (i = 0; i < (size1 / 2); i++)
        {
          sum += ntohs (data1[i]);
        }
      // 
      if (size1 % 2)
        {
          // 
          // The size is odd, and the last octet must
          // be accounted too.
          // 
          octet = (uint8_t *) data1;
          last = octet[size1 - 1];
          last = last << 8;
          sum += last;
        }
    }
  if (data2 != NULL)
    {
      for (i = 0; i < (size2 / 2); i++)
        {
          sum += ntohs (data2[i]);
        }
      // 
      if (size2 % 2)
        {
          // 
          // The size is odd, and the last octet must
          // be accounted too.
          // 
          octet = (uint8_t *) data2;
          last = octet[size2 - 1];
          last = last << 8;
          sum += last;
        }
    }
  // 
  // Extract the carries and make the checksum.
  // 
  carry = sum >> 16;
  checksum = sum & 0x0000FFFF;
  checksum += carry;
  // 
  // End of job.
  // 
  return (checksum);
}
