#include <sys/os32.h>
#include <kernel/net.h>
#include <errno.h>
#include <stdint.h>
#include <arpa/inet.h>
//----------------------------------------------------------
int
net_index_eth (h_addr_t ip, uint8_t mac[6], uintptr_t io)
{
  // 
  int n;
  // 
  // If `ip' is not zero, then find the Ethernet table 
  // index by that
  // value.
  // 
  if (ip != 0)
    {
      for (n = 0; n < NET_MAX_DEVICES; n++)
        {
          if (net_table[n].type & NET_DEV_ETH)
            {
              if (net_table[n].ip == ip)
                {
                  return (n);
                }
            }
        }
    }
  // 
  // By mac address.
  // 
  if (mac != NULL)
    {
      for (n = 0; n < NET_MAX_DEVICES; n++)
        {
          if (net_table[n].type & NET_DEV_ETH)
            {
              if (net_table[n].ethernet.mac[0] ==
                  mac[0]
                  && net_table[n].ethernet.mac[1] ==
                  mac[1]
                  && net_table[n].ethernet.mac[2] ==
                  mac[2]
                  && net_table[n].ethernet.mac[3] ==
                  mac[3]
                  && net_table[n].ethernet.mac[4] ==
                  mac[4]
                  && net_table[n].ethernet.mac[5] == mac[5])
                {
                  return (n);
                }
            }
        }
    }
  // 
  // By hardware I/O address.
  // 
  if (io > 0)
    {
      for (n = 0; n < NET_MAX_DEVICES; n++)
        {
          if (net_table[n].type & NET_DEV_ETH)
            {
              if (net_table[n].ethernet.base_io == io)
                {
                  return (n);
                }
            }
        }
    }
  // 
  // Not found!
  // 
  errset (ENODEV);
  return (-1);
}
