#ifndef _KERNEL_NET_ROUTE_H
#define _KERNEL_NET_ROUTE_H    1
//----------------------------------------------------------
#include <stdint.h>
#include <sys/types.h>
#include <kernel/net.h>
#include <netinet/in.h>
//----------------------------------------------------------
#define ROUTE_MAX_ROUTES 16
//
// Route table element.
//
typedef struct
{
  h_addr_t network;     // 32 bit, host byte order.
  h_addr_t netmask;     // 32 bit, host byte order.
  h_addr_t router;      // 32 bit, host byte order.
  uint8_t m;    // Short netmask.
  uint8_t interface;
} route_t;
//
// External routing table data.
//
extern route_t route_table[ROUTE_MAX_ROUTES];
//----------------------------------------------------------
void route_init (void);
void route_sort (void);
void route_print (void);
h_addr_t route_remote_to_local (h_addr_t remote);
h_addr_t route_remote_to_router (h_addr_t remote);

//----------------------------------------------------------
#endif
