#include <arpa/inet.h>
#include <sys/os32.h>
#include <kernel/net/route.h>
#include <kernel/lib_k.h>
#include <errno.h>
//----------------------------------------------------------
h_addr_t
route_remote_to_local (h_addr_t remote)
{
  int r;        // Routing table index.
  int d;        // Network interface number.
  h_addr_t network;
  // 
  for (r = 0; r < ROUTE_MAX_ROUTES; r++)
    {
      // 
      // Calculate the remote network address based on 
      // the current
      // router item netmask.
      // 
      network = remote & route_table[r].netmask;
      // 
      // Compare the calculated network address with
      // the remote
      // network.
      // 
      if (route_table[r].network == network)
        {
          // 
          // Found.
          // 
          d = route_table[r].interface;
          // 
          // Check inside the network interfaces.
          // 
          if (net_table[d].ip == 0)
            {
              errset (ENODEV);
              return ((h_addr_t) - 1);
            }
          else
            {
              return (net_table[d].ip);
            }
        }
    }
  // 
  // Sorry: destination not found.
  // 
  errset (EADDRNOTAVAIL);
  return ((h_addr_t) - 1);
}
