#include <arpa/inet.h>
#include <sys/os32.h>
#include <kernel/net/route.h>
#include <kernel/lib_k.h>
#include <errno.h>
//----------------------------------------------------------
h_addr_t
route_remote_to_router (h_addr_t remote)
{
  int r;        // Routing table index.
  h_addr_t network;
  // 
  for (r = 0; r < ROUTE_MAX_ROUTES; r++)
    {
      // 
      // Calculate the remote network address based on 
      // the current
      // router item netmask.
      // 
      network = remote & route_table[r].netmask;
      // 
      // Compare the calculated network address with
      // the remote
      // network: routes are sorted, from the most
      // detailed to the
      // less one.
      // 
      if (route_table[r].network == network)
        {
          // 
          // Found.
          // 
          return (route_table[r].router);
        }
    }
  // 
  // Sorry: destination not found.
  // 
  errset (EADDRNOTAVAIL);
  return ((h_addr_t) - 1);
}
