#include <kernel/net.h>
#include <kernel/net/ip.h>
#include <kernel/net/route.h>
#include <kernel/net/tcp.h>
#include <sys/os32.h>
#include <kernel/lib_k.h>
#include <kernel/fs.h>
#include <errno.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
//----------------------------------------------------------
void
tcp_show (h_addr_t src, h_addr_t dst,
          const struct tcphdr *tcphdr)
{
  struct in_addr addr_1;
  struct in_addr addr_2;
  char addr_string_1[INET_ADDRSTRLEN];
  char addr_string_2[INET_ADDRSTRLEN];
  // 
  if (tcphdr == NULL)
    {
      return;
    }
  // 
  addr_1.s_addr = htonl (src);
  addr_2.s_addr = htonl (dst);
  inet_ntop (AF_INET, &addr_1, addr_string_1,
             (socklen_t) sizeof (addr_string_1));
  inet_ntop (AF_INET, &addr_2, addr_string_2,
             (socklen_t) sizeof (addr_string_2));
  k_printf ("TCP %s:%i > %s:%i ", addr_string_1,
            (unsigned int) ntohs (tcphdr->source),
            addr_string_2,
            (unsigned int) ntohs (tcphdr->dest));
  k_printf ("s=%3u ", ntohl (tcphdr->seq));
  k_printf ("k=%3u ", ntohl (tcphdr->ack_seq));

  if (tcphdr->ack)
    k_printf ("ack ");
  if (tcphdr->psh)
    k_printf ("psh ");
  if (tcphdr->rst)
    k_printf ("rst ");
  if (tcphdr->syn)
    k_printf ("syn ");
  if (tcphdr->fin)
    k_printf ("fin ");

  k_printf ("\n");
}
