#ifndef _KERNEL_NET_UDP_H
#define _KERNEL_NET_UDP_H    1
//----------------------------------------------------------
#include <netinet/udp.h>
#include <kernel/net.h>
//----------------------------------------------------------
#define UDP_HEADER_SIZE  8
#define UDP_MAX_PACKET_SIZE  NET_IP_MAX_DATA_SIZE
#define UDP_MAX_DATA_SIZE    \
    UDP_MAX_PACKET_SIZE-UDP_HEADER_SIZE
//----------------------------------------------------------
//
// UDP packet, for transmission.
//
typedef struct
{
  struct udphdr header;
  uint8_t data[UDP_MAX_DATA_SIZE];
} __attribute__ ((packed)) udp_packet_t;
//
// UDP pseudo header for checksum calculation.
//
typedef struct
{
  in_addr_t saddr;
  in_addr_t daddr;
  uint8_t zero;
  uint8_t protocol;
  uint16_t length;
} __attribute__ ((packed)) udp_pseudo_header_t;
//----------------------------------------------------------
int udp_tx (h_port_t sport, h_port_t dport,
            h_addr_t saddr, h_addr_t daddr,
            const void *buffer, size_t size);
//----------------------------------------------------------
#endif
