#ifndef _KERNEL_PART_H
#define _KERNEL_PART_H    1


typedef struct
{
  uint8_t active;       // boot indicator 0 or
  // PART_ACTIVE
  uint8_t h_start;      // head value for first sector
  uint8_t s_start;      // sector value + cyl bits for 
  // first sector
  uint8_t c_start;      // track value for first
  // sector
  uint8_t type; // partition type
  uint8_t h_last;       // head value for last sector
  uint8_t s_last;       // sector value + cyl bits for 
  // last sector
  uint8_t c_last;       // track value for last sector
  uint32_t l_start;     // logical first sector
  uint32_t size;        // size of partition in
  // sectors
} part_t;

#define PART_ACTIVE	0x80    // value for active
                                // partition
#define PART_MAX	4       // number of entries
                                // in partition table
#define	PART_TABLE_OFF	0x1BE   // offset of part.
                                // table in boot
                                // sector

//
// Partition types.
//
#define PART_TYPE_NONE	    0x00        // unused
                                        // entry
#define PART_TYPE_NO_PART   0xFF        // full device
#define PART_TYPE_MINIX	    0x81        // Minix
                                        // partition
                                        // type
#define PART_TYPE_OLDMINIX  0x80        // Minix 1 old
                                        // partition
                                        // type
#define PART_TYPE_EXT  	    0x05        // extended
                                        // partition


#endif
