#include <sys/os32.h>
#include <kernel/proc.h>
#include <kernel/lib_k.h>
//----------------------------------------------------------
void
proc_print (void)
{
  pid_t pid;
  char stat;
  unsigned int min;
  unsigned int sec;
  // 
  // 
  // 
  k_printf
    ("pp  p pg                             T * 0x1000 "
     "D * 0x1000 stack        \n"
     "id id rp  tty  uid euid suid usage s addr  size "
     "addr  size pointer  name\n");
  // 
  // 
  // 
  for (pid = 0; pid < PROCESS_MAX; pid++)
    {
      if (proc_table[pid].status > 0)
        {
          switch (proc_table[pid].status)
            {
            case PROC_EMPTY:
              stat = '-';
              break;
            case PROC_CREATED:
              stat = 'c';
              break;
            case PROC_READY:
              stat = 'r';
              break;
            case PROC_RUNNING:
              stat = 'R';
              break;
            case PROC_SLEEPING:
              stat = 's';
              break;
            case PROC_ZOMBIE:
              stat = 'z';
              break;
            default:
              stat = '?';
              break;
            }
          // 
          min =
            ((proc_table[pid].usage / CLOCKS_PER_SEC) / 60);
          sec =
            ((proc_table[pid].usage / CLOCKS_PER_SEC) % 60);
          // 
          // Addresses and sizes are multiple of 4096
          // (0x1000);
          // for the stack pointer is shown only the
          // last five
          // hexadecimal digits.
          // 
          if (proc_table[pid].domain_data > 0)
            {
              k_printf
                ("%2i %2i %2i %04x %4i %4i "
                 "%4i %02i.%02i %c "
                 "%05x %04x %05x %04x %07x %12s\n",
                 (unsigned int) proc_table[pid].ppid,
                 (unsigned int) pid,
                 (unsigned int) proc_table[pid].pgrp,
                 (unsigned int) proc_table[pid].device_tty,
                 (unsigned int) proc_table[pid].uid,
                 (unsigned int) proc_table[pid].euid,
                 (unsigned int) proc_table[pid].suid,
                 min, sec, stat,
                 (unsigned int) proc_table[pid].address_text
                 / MEM_BLOCK_SIZE,
                 (unsigned int) proc_table[pid].domain_text
                 / MEM_BLOCK_SIZE,
                 (unsigned int) proc_table[pid].address_data
                 / MEM_BLOCK_SIZE,
                 (unsigned int) (proc_table[pid].domain_data
                                 +
                                 proc_table[pid].extra_data)
                 / MEM_BLOCK_SIZE,
                 (unsigned int) proc_table[pid].sp,
                 proc_table[pid].name);
            }
          else
            {
              k_printf
                ("%2i %2i %2i %04x %4i %4i %4i "
                 "%02i.%02i %c "
                 "%05x %04x %05x %04x %07x %12s\n",
                 (unsigned int) proc_table[pid].ppid,
                 (unsigned int) pid,
                 (unsigned int) proc_table[pid].pgrp,
                 (unsigned int) proc_table[pid].device_tty,
                 (unsigned int) proc_table[pid].uid,
                 (unsigned int) proc_table[pid].euid,
                 (unsigned int) proc_table[pid].suid,
                 min, sec, stat,
                 (unsigned int) proc_table[pid].address_text
                 / MEM_BLOCK_SIZE,
                 (unsigned int) (proc_table[pid].domain_text
                                 +
                                 proc_table[pid].extra_data)
                 / MEM_BLOCK_SIZE,
                 (unsigned int) proc_table[pid].address_data
                 / MEM_BLOCK_SIZE,
                 (unsigned int) proc_table[pid].domain_data
                 / MEM_BLOCK_SIZE,
                 (unsigned int) proc_table[pid].sp,
                 proc_table[pid].name);
            }
        }
    }
}
