#include <kernel/proc.h>
#include <kernel/lib_k.h>
#include <kernel/lib_s.h>
//----------------------------------------------------------
void
proc_sch_timers (void)
{
  static unsigned long long int previous_time;
  unsigned long long int current_time;
  unsigned int pid;
  current_time = s_time ((pid_t) 0, NULL);
  if (previous_time != current_time)
    {
      for (pid = 0; pid < PROCESS_MAX; pid++)
        {
          if ((proc_table[pid].wakeup_events &
               WAKEUP_EVENT_TIMER)
              && (proc_table[pid].status == PROC_SLEEPING)
              && (proc_table[pid].wakeup_timer > 0))
            {
              proc_table[pid].wakeup_timer--;
              if (proc_table[pid].wakeup_timer == 0)
                {
                  proc_table[pid].status = PROC_READY;
                }
            }
        }
    }
  previous_time = current_time;
}
