#include <kernel/proc.h>
#include <kernel/lib_s.h>
#include <kernel/lib_k.h>
//----------------------------------------------------------
void
proc_sig_term (pid_t pid, int sig)
{
  if (proc_sig_status (pid, sig))
    {
      if (proc_sig_ignore (pid, sig) && !(sig == SIGKILL))
        {
          proc_sig_off (pid, sig);
        }
      else
        {
          if ((proc_table[pid].sig_handler[sig] !=
               (uintptr_t) NULL) && (sig != SIGKILL))
            {
              proc_sig_handler (pid, sig);
            }
          else
            {
              // 
              // The signal, translated to negative,
              // is returned (but
              // the effective value received by the
              // application will
              // be cutted, leaving only the low 8
              // bit).
              // 
              s__exit (pid, -sig);
            }
        }
    }
}
