#ifndef _DIRENT_H
#define _DIRENT_H        1

#include <sys/types.h>  // ino_t
#include <limits.h>     // NAME_MAX

//----------------------------------------------------------
struct dirent
{
  ino_t d_ino;  // I-node number [1]
  char d_name[NAME_MAX + 1];    // NAME_MAX + Null
  // termination
} __attribute__ ((packed));
//
// [1] The type `ino_t' must be equal to `uint16_t',
//     because the directory inside the Minix 1 file
//     system has exactly such size.
//
//----------------------------------------------------------
#define DOPEN_MAX   OPEN_MAX/2  // <limits.h> [1]
//
// [1] DOPEN_MAX is not standard, but it is used to
//     define how many directory slot to keep for open
//     directories. As directory streams are opened as
//     file descriptors, the sum of all kind of file
//     open cannot be more than OPEM_MAX.
//----------------------------------------------------------
typedef struct
{
  int fdn;      // File descriptor number.
  struct dirent dir;    // Last directory item read.
} DIR;

extern DIR _directory_stream[]; // Defined inside
                                // `lib/dirent/DIR.c'.
//----------------------------------------------------------
// Function prototypes.
//----------------------------------------------------------
int closedir (DIR * dp);
DIR *opendir (const char *name);
struct dirent *readdir (DIR * dp);
void rewinddir (DIR * dp);
//----------------------------------------------------------

#endif
