#include <dirent.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stddef.h>
//----------------------------------------------------------
int
closedir (DIR * dp)
{
  // 
  // Check for a valid argument
  // 
  if (dp == NULL)
    {
      // 
      // Not a valid pointer.
      // 
      errset (EBADF);   // Invalid directory.
      return (-1);
    }
  // 
  // Check if it is an open directory stream.
  // 
  if (dp->fdn < 0)
    {
      // 
      // The stream is closed.
      // 
      errset (EBADF);   // Invalid directory.
      return (-1);
    }
  // 
  // Close the file descriptor. It there is an error,
  // the `errno' variable will be set by `close()'.
  // 
  return (close (dp->fdn));
}
