#include <pwd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
//----------------------------------------------------------
static char buffer[BUFSIZ];
static struct passwd pw;
static FILE *fp = NULL;
//----------------------------------------------------------
struct passwd *
getpwent (void)
{
  void *pstatus;
  char *char_uid;
  char *char_gid;
  // 
  if (fp == NULL)
    {
      fp = fopen ("/etc/passwd", "r");
      if (fp == NULL)
        {
          return NULL;
        }
    }
  // 
  pstatus = fgets (buffer, BUFSIZ, fp);
  if (pstatus == NULL)
    {
      return (NULL);
    }
  // 
  // The parse is made with `strtok()'. Please notice
  // that
  // `strtok()' will not parse a line like the
  // following:
  // user::1001:233:...
  // The password field *must* have something,
  // otherwise the
  // UID will take the password place.
  // `strtok()' will consider `::' the same as `:'!
  // 
  pw.pw_name = strtok (buffer, ":");
  pw.pw_passwd = strtok (NULL, ":");
  char_uid = strtok (NULL, ":");
  char_gid = strtok (NULL, ":");
  pw.pw_gecos = strtok (NULL, ":");
  pw.pw_dir = strtok (NULL, ":");
  pw.pw_shell = strtok (NULL, "\n");
  pw.pw_uid = (uid_t) atoi (char_uid);
  pw.pw_gid = (gid_t) atoi (char_gid);
  // 
  return (&pw);
}

//----------------------------------------------------------
void
endpwent (void)
{
  int status;
  // 
  if (fp != NULL)
    {
      status = fclose (fp);
      if (status != 0)
        {
          perror (NULL);
          fp = NULL;
        }
      else
        {
          ;     // printf ("[%s] fclose (fp)\n",
          // __func__);
        }
    }
}

//----------------------------------------------------------
void
setpwent (void)
{
  if (fp != NULL)
    {
      rewind (fp);
    }
}

//----------------------------------------------------------
struct passwd *
getpwnam (const char *name)
{
  struct passwd *pw;
  // 
  setpwent ();
  // 
  for (;;)
    {
      pw = getpwent ();
      if (pw == NULL)
        {
          return (NULL);
        }
      if (strcmp (pw->pw_name, name) == 0)
        {
          return (pw);
        }
    }
}

//----------------------------------------------------------
struct passwd *
getpwuid (uid_t uid)
{
  struct passwd *pw;
  // 
  setpwent ();
  // 
  for (;;)
    {
      pw = getpwent ();
      if (pw == NULL)
        {
          return (NULL);
        }
      if (pw->pw_uid == uid)
        {
          return (pw);
        }
    }
}
