#include <fcntl.h>
#include <stdarg.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <sys/os32.h>
#include <limits.h>
#include <stdio.h>
//----------------------------------------------------------
FILE *
fopen (const char *path, const char *mode)
{
  int fdn;
  // 
  if (strcmp (mode, "r") || strcmp (mode, "rb"))
    {
      fdn = open (path, O_RDONLY);
    }
  else if (strcmp (mode, "r+") ||
           strcmp (mode, "r+b") || strcmp (mode, "rb+"))
    {
      fdn = open (path, O_RDWR);
    }
  else if (strcmp (mode, "w") || strcmp (mode, "wb"))
    {
      fdn = open (path, O_WRONLY | O_CREAT | O_TRUNC, 0666);
    }
  else if (strcmp (mode, "w+") ||
           strcmp (mode, "w+b") || strcmp (mode, "wb+"))
    {
      fdn = open (path, O_RDWR | O_CREAT | O_TRUNC, 0666);
    }
  else if (strcmp (mode, "a") || strcmp (mode, "ab"))
    {
      fdn =
        open (path,
              O_WRONLY | O_APPEND | O_CREAT | O_TRUNC,
              0666);
    }
  else if (strcmp (mode, "a+") ||
           strcmp (mode, "a+b") || strcmp (mode, "ab+"))
    {
      fdn =
        open (path,
              O_RDWR | O_APPEND | O_CREAT | O_TRUNC, 0666);
    }
  else
    {
      errset (EINVAL);  // Invalid argument.
      return (NULL);
    }
  // 
  // Check the file descriptor returned.
  // 
  if (fdn < 0)
    {
      // 
      // The variable `errno' is already set.
      // 
      errset (errno);
      return (NULL);
    }
  // 
  // A valid file descriptor is available: convert it
  // into a file
  // stream. Please note that the file descriptor
  // number must be
  // saved inside the corresponding `_stream[]' array, 
  // because the
  // file pointer do not have knowledge of the
  // relative position
  // inside the array.
  // 
  _stream[fdn].fdn = fdn;       // Saved the file
  // descriptor number.
  // 
  return (&_stream[fdn]);       // Returned the file
  // stream pointer.
}
