#include <stdlib.h>
#include <sys/types.h>
#include <signal.h>
#include <unistd.h>
//----------------------------------------------------------
void
abort (void)
{
  pid_t pid;
  sighandler_t sig_previous;
  // 
  // Set `SIGABRT' to a default action.
  // 
  sig_previous = signal (SIGABRT, SIG_DFL);
  // 
  // If the previous action was something different
  // than symbolic
  // ones, configure again the previous action.
  // 
  if (sig_previous != SIG_DFL &&
      sig_previous != SIG_IGN && sig_previous != SIG_ERR)
    {
      signal (SIGABRT, sig_previous);
    }
  // 
  // Get current process ID and sent the signal.
  // 
  pid = getpid ();
  kill (pid, SIGABRT);
  // 
  // Second chance
  // 
  for (;;)
    {
      signal (SIGABRT, SIG_DFL);
      pid = getpid ();
      kill (pid, SIGABRT);
    }
}
