#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <stdint.h>
//----------------------------------------------------------
extern uintptr_t _alloc_start;
//----------------------------------------------------------
void
_alloc_list (void)
{
  uintptr_t start = _alloc_start;
  uintptr_t end = (uintptr_t) sbrk (0);
  _alloc_head_t *head = (void *) start;
  size_t actual_size;
  uintptr_t current;
  uintptr_t next;
  uintptr_t up_to;
  int counter;
  // 
  // Scandisce la lista di blocchi di memoria.
  // 
  counter = 2;
  while (counter)
    {
      // 
      // Annota la posizione attuale e quella
      // successiva.
      // 
      current = (uintptr_t) head;
      next = head->next * (sizeof (_alloc_head_t));
      if (next == start)
        {
          up_to = end;
        }
      else
        {
          up_to = next;
        }
      // 
      // Se è stato raggiunto il primo elemento,
      // decrementa il
      // contatore di una unità. Se è già a zero,
      // esce.
      // 
      if (current == start)
        {
          counter--;
          if (counter == 0)
            break;
        }
      // 
      // Determina la dimensione del blocco attuale.
      // 
      if (current == start && next == start)
        {
          // 
          // Si tratta del primo e unico elemento
          // della lista.
          // 
          actual_size =
            end - start - (sizeof (_alloc_head_t));
        }
      else
        {
          actual_size =
            up_to - current - (sizeof (_alloc_head_t));
        }
      // 
      // Si mostra lo stato del blocco di memoria.
      // 
      if (head->allocated)
        {
          printf ("[%s] used %08X..%08X size %08zX\n",
                  __func__,
                  current + (sizeof (_alloc_head_t)),
                  up_to, actual_size);
        }
      else
        {
          printf ("[%s] free %08X..%08X size %08zX\n",
                  __func__,
                  current + (sizeof (_alloc_head_t)),
                  up_to, actual_size);
        }
      // 
      // Si passa alla posizione successiva.
      // 
      head = (void *) next;
    }
}
