#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
//----------------------------------------------------------
extern uintptr_t _alloc_start;
//----------------------------------------------------------
void
free (void *ptr)
{
  _alloc_head_t *start = (_alloc_head_t *) _alloc_start;
  _alloc_head_t *head_current = ((_alloc_head_t *) ptr) - 1;
  _alloc_head_t *head_next;
  // 
  // Verifica il blocco attuale e, se è possibile, lo 
  // libera.
  // 
  if (head_current->allocated == 1)
    {
      head_current->allocated = 0;
    }
  else
    {
      printf ("[%s] ERROR: cannot free %08X!\n",
              __func__,
              (uintptr_t) head_current +
              (sizeof (_alloc_head_t)));
    }
  // 
  // Scandisce i blocchi liberi, cercando quelli
  // adiacenti per
  // allungarli. Se il blocco successivo è il primo,
  // termina,
  // perché non può avvenire alcuna fusione con
  // quello precedente.
  // 
  head_current = start;
  while (1)
    {
      // 
      // Individua il blocco successivo.
      // 
      head_next =
        (_alloc_head_t *) (head_current->next
                           * (sizeof (_alloc_head_t)));
      // 
      // Controlla se è il primo.
      // 
      if (head_next == start)
        {
          break;
        }
      // 
      // 
      // 
      if (head_current->allocated == 0)
        {
          // 
          // Controlla se si può espandere.
          // 
          if (head_next->allocated == 0)
            {
              head_current->next = head_next->next;
            }
          else
            {
              head_current = head_next;
            }
        }
      else
        {
          head_current = (_alloc_head_t *)
            (head_current->next * (sizeof (_alloc_head_t)));
        }
    }
}
