#include <string.h>
//----------------------------------------------------------
void *
memmove (void *dst, const void *org, size_t n)
{
  char *d = (char *) dst;
  char *o = (char *) org;
  size_t i;
  // 
  // Depending on the memory start locations, copy may 
  // be direct or
  // reverse, to avoid overwriting before the
  // relocation is done.
  // 
  if (d < o)
    {
      for (i = 0; i < n; i++)
        {
          d[i] = o[i];
        }
    }
  else if (d == o)
    {
      // 
      // Memory locations are already the same.
      // 
      ;
    }
  else
    {
      for (i = n - 1; i >= 0; i--)
        {
          d[i] = o[i];
        }
    }
  return dst;
}
