#ifndef _SYS_SOCKET_H
#define _SYS_SOCKET_H    1
//----------------------------------------------------------
#include <stdint.h>
#include <unistd.h>
#include <sys/socklen_t.h>
#include <sys/sa_family_t.h>
//----------------------------------------------------------
struct sockaddr
{
  sa_family_t sa_family;        // Address family.
  char sa_data[14];     // Socket address.
};
//
//
//
struct sockaddr_storage
{
  sa_family_t ss_family;        // Socket storage
  // family.
  uint8_t ss_zero[14];  // Filler.
};
//
//
//
#define SOCK_STREAM    1        // Byte-stream socket.
#define SOCK_DGRAM     2        // Datagram socket.
#define SOCK_RAW       3        // Raw protocol
                                // interface.
#define SOCK_SEQPACKET 5        // Sequenced-packet
                                // socket.
//
// Protocol families:
//
#define PF_UNSPEC       0       // Unspecified.
#define PF_UNIX         1       // Unix domain socket.
#define PF_INET         2       // IPv4 protocol
                                // family.
#define PF_INET6        10      // IPv6 protocol
                                // family.
//
// Address families.
//
#define AF_UNSPEC  PF_UNSPEC    // Unspecified.
#define AF_UNIX    PF_UNIX      // Unix domain socket.
#define AF_INET    PF_INET      // IPv4 address
                                // family.
#define AF_INET6   PF_INET6     // IPv6 address
                                // family.
//----------------------------------------------------------
int accept (int sfdn, struct sockaddr *addr,
            socklen_t * addrlen);
int bind (int sfdn, const struct sockaddr *addr,
          socklen_t addrlen);
int connect (int sfdn, const struct sockaddr *addr,
             socklen_t addrlen);
int listen (int sfdn, int backlog);
ssize_t send (int sfdn, const void *buffer,
              size_t count, int flags);
ssize_t recvfrom (int sfdn, void *buffer, size_t count,
                  int flags, struct sockaddr *addrfrom,
                  socklen_t * addrlen);
int socket (int family, int type, int protocol);

#define recv(sdfn, buffer, count, flags) \
    recvfrom (sdfn, buffer, count, flags, NULL, NULL)
//----------------------------------------------------------
#endif
