#ifndef _TIME_H
#define _TIME_H       1
//----------------------------------------------------------
#include <restrict.h>
#include <size_t.h>
#include <time_t.h>
#include <clock_t.h>
#include <NULL.h>
#include <stdint.h>
//----------------------------------------------------------
#define CLOCKS_PER_SEC  ((clock_t) 100)
//----------------------------------------------------------
struct tm
{
  int tm_sec;
  int tm_min;
  int tm_hour;
  int tm_mday;
  int tm_mon;
  int tm_year;
  int tm_wday;
  int tm_yday;
  int tm_isdst;
};
//----------------------------------------------------------
clock_t clock (void);
time_t time (time_t * timer);
int stime (time_t * timer);
double difftime (time_t time1, time_t time0);
time_t mktime (const struct tm *timeptr);
struct tm *gmtime (const time_t * timer);
struct tm *localtime (const time_t * timer);
char *asctime (const struct tm *timeptr);
char *ctime (const time_t * timer);
size_t strftime (char *restrict s, size_t maxsize,
                 const char *restrict format,
                 const struct tm *restrict timeptr);
//----------------------------------------------------------
#define difftime(t1,t0) ((double)((t1)-(t0)))
#define ctime(t)        (asctime (localtime (t)))
#define localtime(t)    (gmtime (t))
//----------------------------------------------------------
#endif
