#include <unistd.h>
#include <sys/stat.h>
#include <errno.h>
//----------------------------------------------------------
int
access (const char *path, int mode)
{
  struct stat st;
  int status;
  uid_t euid;
  // 
  status = stat (path, &st);
  if (status != 0)
    {
      return (-1);
    }
  // 
  // File exists?
  // 
  if (mode == F_OK)
    {
      return (0);
    }
  // 
  // Some access permissions are requested: get
  // effective user id.
  // 
  euid = geteuid ();
  // 
  // Check owner access permissions.
  // 
  if (st.st_uid == euid
      && ((st.st_mode & S_IRWXU) == (mode << 6)))
    {
      return (0);
    }
  // 
  // Check others access permissions.
  // 
  if ((st.st_mode & S_IRWXO) == (mode))
    {
      return (0);
    }
  // 
  // Otherwise there are no access permissions.
  // 
  errset (EACCES);      // Permission denied.
  return (-1);
}
