#include <unistd.h>
#include <sys/types.h>
#include <sys/os32.h>
#include <errno.h>
#include <string.h>
//----------------------------------------------------------
pid_t
fork (void)
{
  sysmsg_fork_t msg;
  // 
  // Set the return value for the child process.
  // 
  msg.ret = 0;
  // 
  // Do the system call.
  // 
  sys (SYS_FORK, &msg, (sizeof msg));
  // 
  // If the system call has successfully generated a
  // copy of
  // the original process, the following code is
  // executed from
  // the parent and the child. But the child has the
  // `msg'
  // structure untouched, while the parent has, at
  // least, the
  // pid number inside `msg.ret'.
  // If the system call fails, there is no child, and
  // the
  // parent finds the return value equal to -1, with
  // an
  // error number.
  // 
  errno = msg.errno;
  errln = msg.errln;
  strncpy (errfn, msg.errfn, PATH_MAX);
  return (msg.ret);
}
