#include <unistd.h>
#include <sys/types.h>
#include <sys/os32.h>
#include <errno.h>
#include <stddef.h>
#include <string.h>
//----------------------------------------------------------
char *
getcwd (char *buffer, size_t size)
{
  sysmsg_uarea_t msg;
  // 
  // Check arguments: the buffer must be given.
  // 
  if (buffer == NULL)
    {
      errset (EINVAL);
      return (NULL);
    }
  // 
  msg.path_cwd = buffer;
  msg.path_cwd_size = size;
  // 
  // Set the last buffer element to zero, for later
  // verification.
  // 
  buffer[size - 1] = 0;
  // 
  // Just get the user area data.
  // 
  sys (SYS_UAREA, &msg, (sizeof msg));
  // 
  // Check that the path is still correctly
  // terminated. If it isn't,
  // the path is longer than the buffer size, because
  // the last null
  // character was overwritten.
  // 
  if (buffer[size - 1] != 0)
    {
      errset (ERANGE);
      return (NULL);
    }
  // 
  // Everything is fine.
  // 
  return (buffer);
}
