#include <sys/os32.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/types.h>
#include <errno.h>
#include <limits.h>
//----------------------------------------------------------
char *
ttyname (int fdn)
{
  dev_t dev_minor;
  struct stat file_status;
  static char name[PATH_MAX];
  // 
  // Verify to have valid input data.
  // 
  if (fdn < 0)
    {
      errset (EBADF);
      return (NULL);
    }
  // 
  // Verify the file descriptor.
  // 
  if (fstat (fdn, &file_status) == 0)
    {
      if (major (file_status.st_rdev) == DEV_CONSOLE_MAJOR)
        {
          dev_minor = minor (file_status.st_rdev);
          // 
          // If minor is equal to 0xFF, it is
          // `/dev/console'.
          // 
          if (dev_minor < 0xFF)
            {
              sprintf (name, "/dev/console%i", dev_minor);
            }
          else
            {
              strcpy (name, "/dev/console");
            }
          return (name);
        }
      else if (file_status.st_rdev == DEV_TTY)
        {
          strcpy (name, "/dev/tty");
          return (name);
        }
      else
        {
          errset (ENOTTY);
          return (NULL);
        }
    }
  else
    {
      errset (errno);
      return (NULL);
    }
}
