#include <unistd.h>
#include <sys/os32.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
//----------------------------------------------------------
ssize_t
write (int fdn, const void *buffer, size_t count)
{
  sysmsg_write_t msg;
  // 
  // Reduce size of write if necessary.
  // 
  if (count > BUFSIZ)
    {
      count = BUFSIZ;
    }
  // 
  // Fill the message.
  // 
  msg.fdn = fdn;
  msg.buffer = buffer;
  msg.count = count;
  // 
  // Syscall.
  // 
  sys (SYS_WRITE, &msg, (sizeof msg));
  // 
  // Check result and return.
  // 
  if (msg.ret < 0)
    {
      // 
      // No valid write.
      // 
      errno = msg.errno;
      errln = msg.errln;
      strncpy (errfn, msg.errfn, PATH_MAX);
      return (msg.ret);
    }
  // 
  if (msg.ret > count)
    {
      // 
      // A strange value was returned. Considering it
      // a read error.
      // 
      errset (EIO);     // I/O error.
      return (-1);
    }
  // 
  // A valid write return.
  // 
  return (msg.ret);
}
